<template>

  </template>

<script setup lang="ts">
  import { postUser } from '../composition-api/administrations.api';
  import { useMsal } from "../composition-api/useMsal";
  import { InteractionRequiredAuthError, InteractionStatus } from "@azure/msal-browser";
  import { reactive, onMounted, watch ,ref} from 'vue'
  import { loginRequest } from "../authConfig";
  import { callMsGraph, callMsGraphImg } from "../utils/MsGraphApiCall";
  import UserInfo from "../utils/UserInfo";

  const { instance, inProgress } = useMsal();

  const state = reactive({
    resolved: false,
    data: {} as UserInfo
  });
  async function getGraphData() {
      const response = await instance.acquireTokenSilent({
          ...loginRequest
      }).catch(async (e) => {
          if (e instanceof InteractionRequiredAuthError) {
              await instance.acquireTokenRedirect(loginRequest);
          }
          throw e;
      });
    if (inProgress.value === InteractionStatus.None) {
      const graphData = await callMsGraph(response.accessToken);
      state.data = graphData;
      const graphDataImg = await callMsGraphImg(response.accessToken);
      state.resolved = true;
    }
  }

  onMounted(async() => {
    console.log('ici')
    await getGraphData(),
    await sendUser(state.data);
  });

  async function sendUser(account:any){

    await postUser({
      name:account.name,
      mail: account.mail,
      microsoft_id : account.id
  });

}

</script>
